program JACOBI
!
  implicit none
!
  integer :: n, i, j, niter
  real*8  :: alpha, h, h2, eps, norme
  real*8, dimension(:,:), allocatable  :: A
  real*8, dimension(:), allocatable  :: b, x, y, r
  real*8  :: temps, t_cpu_0, t_cpu_1, t_cpu
  integer :: ir, t1, t2
!
  open (unit=100, file='donnees', status='old')
   read(100,*) n, alpha, eps
  close (100)
!
  allocate (A(n,n), b(n), x(n), y(n), r(n))
!
  h  = 1./float(n+1)
  h2 = 1./h**2
!
  A=0.
  i=1
  A(i  ,i)=(+2.d0+alpha)*h2
  A(i+1,i)=-1.d0*h2
  do i = 2, n-1
   A(i-1,i)=-1.d0*h2
   A(i  ,i)=(+2.d0+alpha)*h2
   A(i+1,i)=-1.d0*h2
  end do
  i=n
  A(i-1,i)=-1.d0*h2
  A(i  ,i)=(+2.d0+alpha)*h2
!
  b=0.
  b(1) = A(1,1) + A(2,1)
  do i = 2, n-1
   b(i) = A(i-1,i) + A(i,i) + A(i+1,i)
  end do
  b(n) = A(n-1,n) + A(n,n)
!
  ! Solution initiale
  x = 0.
!
  ! Temps CPU de calcul initial
  call cpu_time(t_cpu_0)
!
  ! Temps elapsed de reference.
  call system_clock(count=t1, count_rate=ir)
!
  niter = 0
  ! Resolution par la methode de Jacobi
  do
     niter = niter+ 1
     y = x
     do i = 1, n
        x(i) = 0.
        do j = 1, i-1
           x(i) = x(i) + A(i,j)*y(j)
        end do
        do j = i+1, n
           x(i) = x(i) + A(i,j)*y(j)
        end do
        x(i) = (b(i) - x(i))/A(i,i)
     end do
     ! Test de convergence
     norme = maxval(abs(x-y))
     if (norme <= eps) exit
  end do
!
  ! Temps elapsed final
  call system_clock(count=t2, count_rate=ir)
  temps=(t2-t1)/float(ir)
!
  ! Temps CPU de calcul final
  call cpu_time(t_cpu_1)
  t_cpu = t_cpu_1 - t_cpu_0
!
  ! Impression du resultat
  print '(3X,"Taille du systeme   : ",I8,/       &
        &,3X,"Iterations          : ",I8,/       &
        &,3X,"Norme               : ",E10.3,/  &
        &,3X,"Temps elapsed       : ",E10.3," sec.",/ &
        &,3X,"Temps CPU           : ",E10.3," sec.",//)',n,niter,norme,temps,t_cpu
!
  open (unit=200, file='solution', status='unknown')
   write(200,*) x
  close (200)
!
end program JACOBI
