#include "mpi.h"
#include <stdio.h>
#include <stdlib.h>

nint(double a){
   if (a>0){
     return (int)(a+0.5);
   }
   return (int)(a-0.5);
}

int main (int argc,char *argv[])

{

  int        nb_processus, rang ;
  int        i, j, ng, nl1, nl2, nl, p, q, pq ;
  double     **A ;
  double     traceloc, traceglob, xy, h ;
  FILE       *fichier ;
  
  MPI_Init (&argc, &argv) ;
  MPI_Comm_rank (MPI_COMM_WORLD, &rang) ;
  MPI_Comm_size (MPI_COMM_WORLD, &nb_processus) ;
   
if (rang == 0)
 {
 fichier = fopen("donnees", "r");
  fscanf (fichier, "%d", &ng) ;
 fclose(fichier);
 }
   
  MPI_Bcast (&ng, 1, MPI_INTEGER, 0, MPI_COMM_WORLD) ;

  h = (double)1/(double)ng ;
  nl1 = nint((double)ng/(double)nb_processus) ;
  nl2 = ng - (nl1*(nb_processus-1)) ;
  nl = nl1 ;
  if (rang==nb_processus-1) nl = nl2 ;
  p = 1+(nl1*rang) ;
  q = nl+(nl1*rang) ;
  pq = q-p+1 ;
  A=(double **) malloc(nl*sizeof(double*)); 
   
 for (i = 0; i <=nl-1; i++)
   A[i]=(double *) malloc(nl*sizeof(double)); 
 for (i = 0; i <=nl-1; i++)
 { 
  for (j = 0; j <=nl-1; j++)
  { 
    xy= ((double)i+p)*((double)j+p)*(h*h) ;
    A[i][j]=xy ;
  } 
 } 
   
 traceloc = 0.;
 for (i = 0; i <=nl-1; i++)
    traceloc = traceloc + A[i][i] ;
  printf ("Moi processus de rang %d, j'ai une sous-matrice carree de taille %d et ma trace locale est egale a %.9f\n", rang, pq, traceloc) ;

  MPI_Reduce (&traceloc, &traceglob, 1, MPI_DOUBLE, MPI_SUM, 0, MPI_COMM_WORLD) ;

 if (rang == 0) printf ("Moi processus de rang %d, je recupere la trace globale de la matrice carree de taille %d et cette trace est egale a %.9f\n", rang, ng, traceglob) ;
   
  free (A) ;
   
  MPI_Finalize() ;

}
