program trace
 
  use mpi
 
  implicit none
  integer                              :: nb_processus, rang, code
  real*8, dimension (:,:), allocatable :: A 
  real*8                               :: traceloc, traceglob, xy, h
  integer                              :: i, j, ng, nl1, nl2, nl, p, q, pq

  call MPI_INIT (code)
  call MPI_COMM_RANK (MPI_COMM_WORLD, rang, code)
  call MPI_COMM_SIZE (MPI_COMM_WORLD, nb_processus, code)

  open (unit=100, file='donnees', status='old')
   read(100,*) ng
  close (100)
 
  call MPI_BCAST (ng, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, code)
 
  h = 1.D0/dfloat(ng)
  nl1 = nint(dfloat(ng)/dfloat(nb_processus))
  nl2 = ng - (nl1*(nb_processus-1))
  nl = nl1
  if (rang==nb_processus-1) nl = nl2
  p = 1+(nl1*rang)
  q = nl+(nl1*rang)
  pq = q-p+1
  allocate (A(p:q, p:q))
!
  do j = p, q
   do i = p, q
    xy = dfloat(i)*dfloat(j)*(h**2)
    A(i,j)=xy
   end do
  end do
 
  traceloc = 0.
  do i = p, q
   traceloc = traceloc + A(i,i)
  end do
  print '("Moi processus de rang ",I2, &
          ", j""ai une sous matrice carree de taille ",I10, &
          "  et ma trace locale est egale a ",F16.9)',rang, pq, traceloc

  call MPI_REDUCE (traceloc, traceglob, 1, MPI_DOUBLE_PRECISION, MPI_SUM, 0,MPI_COMM_WORLD, code)
 
  if (rang == 0) then
   print '("Moi processus de rang ",I2, &
           ", je recupere la trace globale de la matrice carree de taille ",I10, &
           "  et cette trace est egale a ",F16.9)',rang, ng, traceglob
  end if
 
  deallocate (A)
 
  call MPI_FINALIZE (code)
 
end program trace
