!================
module mod_pdscal
!================
!
!==========================
interface operator (.scal.)
!==========================
!
        module procedure pdscal
!
!============
end interface
!============
!
!============================
interface operator (.scaloc.)
!============================
!
        module procedure pdscaloc
!
!============
end interface
!============
!
contains
!
!=====================
function pdscal (x, y)
!=====================
!
        use mpi
        use mod_dataproc
!
        implicit none
!
        real(kind=8), dimension (:), intent (in) :: x, y
        real(kind=8) :: pdscal, pdscalloc
        integer :: n, i
!
        n = size(x)
!
        pdscalloc = 0.d0
        do i = 1, n
         pdscalloc = pdscalloc + x(i)*y(i)
        end do
!
        call MPI_ALLREDUCE (pdscalloc, pdscal, 1, MPI_DOUBLE_PRECISION, MPI_SUM, MPI_COMM_WORLD, code)
!
!==================
end function pdscal
!==================
!
!=======================
function pdscaloc (x, y)
!=======================
!
        implicit none
!
        real(kind=8), dimension (:), intent (in) :: x, y
        real(kind=8) :: pdscaloc
        integer :: n, i
!
        n = size(x)
!
        pdscaloc = 0.d0
        do i = 1, n
         pdscaloc = pdscaloc + x(i)*y(i)
        end do
!
!====================
end function pdscaloc
!====================
!
!====================
end module mod_pdscal
!====================
