program PI
!
!$ use OMP_LIB
!
  implicit none
!
  integer :: n
  real*8  :: xi, h, Pi_exact, Pi_calcule, ecart
  integer :: i
  real*8  :: temps, t_cpu_0, t_cpu_1, t_cpu
  integer :: ir, t1, t2
!
!$ integer :: nb_taches, rang
!
  !$OMP PARALLEL
  !$ nb_taches = OMP_GET_NUM_THREADS()
  !$ rang = OMP_GET_THREAD_NUM ()
  !$ print '("Numero de thread ",i2," parmi ",i2," thread(s)")',rang, nb_taches
  !$OMP END PARALLEL
!
  open (unit=100, file='donnees', status='old')
   read(100,*) n
  close (100)
!
  ! Valeur estimée de Pi
  Pi_exact = acos(-1.D0)
!
  ! Temps CPU de calcul initial
  call cpu_time(t_cpu_0)
!
  ! Temps elapsed de reference.
  call system_clock(count=t1, count_rate=ir)
!
   h = 1./ float(n)
   ! Calcul de Pi
   Pi_calcule = 0.D0
   !$OMP PARALLEL 
   !$OMP DO PRIVATE(xi) REDUCTION(+ : Pi_calcule)
   do i = 1, n
    xi = h * (float(i)-0.5)
    Pi_calcule = Pi_calcule + f(xi)
   end do
   !$OMP END DO
   !$OMP END PARALLEL
   Pi_calcule = h * Pi_calcule
   ecart = abs(Pi_exact - Pi_calcule)
!
  ! Temps elapsed final
  call system_clock(count=t2, count_rate=ir)
  temps=(t2-t1)/float(ir)
!
  ! Temps CPU de calcul final
  call cpu_time(t_cpu_1)
  t_cpu = t_cpu_1 - t_cpu_0
!
  ! Impression du resultat.
  print '("Nombre d''intervalles            : ",I10,/  &
           &,3X,"| Pi_exact - Pi_calcule |  : ",1D10.3,/  &
           &,3X,"Temps elapsed              : ",1D10.3," sec.",/ &
           &,3X,"Temps CPU                  : ",1D10.3," sec.",//)',n, ecart, temps, t_cpu
!
  CONTAINS
   function f(x)
    implicit none
    real*8, intent(in) :: x
    real*8 :: f
    f = 4.D0 / (1.D0 + x**2)
   end function f
!
end program PI
